/[gentoo-x86]/eclass/flag-o-matic.eclass
Gentoo

Diff of /eclass/flag-o-matic.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.40 Revision 1.136
1# Copyright 1999-2003 Gentoo Technologies, Inc. 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.40 2004/03/12 11:21:15 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.136 2009/05/23 23:12:07 vapier Exp $
4
5# @ECLASS: flag-o-matic.eclass
6# @MAINTAINER:
7# toolchain@gentoo.org
8# @BLURB: common functions to manipulate and query toolchain flags
9# @DESCRIPTION:
10# This eclass contains a suite of functions to help developers sanely
11# and safely manage toolchain flags in their builds.
12
13inherit eutils toolchain-funcs multilib
14
15################ DEPRECATED functions ################
16# The following are still present to avoid breaking existing
17# code more than necessary; however they are deprecated. Please
18# use gcc-specs-* from toolchain-funcs.eclass instead, if you
19# need to know which hardened techs are active in the compiler.
20# See bug #100974
4# 21#
5# Author Bart Verwilst <verwilst@gentoo.org> 22# has_hardened
23# has_pie
24# has_pic
25# has_ssp_all
26# has_ssp
6 27
7ECLASS=flag-o-matic
8INHERITED="$INHERITED $ECLASS"
9 28
10#
11#### filter-flags <flags> ####
12# Remove particular flags from C[XX]FLAGS
13# Matches only complete flags
14#
15#### append-flags <flags> ####
16# Add extra flags to your current C[XX]FLAGS
17#
18#### replace-flags <orig.flag> <new.flag> ###
19# Replace a flag by another one
20#
21#### replace-cpu-flags <new.cpu> <old.cpus> ###
22# Replace march/mcpu flags that specify <old.cpus>
23# with flags that specify <new.cpu>
24#
25#### is-flag <flag> ####
26# Returns "true" if flag is set in C[XX]FLAGS
27# Matches only complete a flag
28#
29#### strip-flags ####
30# Strip C[XX]FLAGS of everything except known
31# good options.
32#
33#### strip-unsupported-flags ####
34# Strip C[XX]FLAGS of any flags not supported by
35# installed version of gcc
36#
37#### get-flag <flag> ####
38# Find and echo the value for a particular flag
39#
40#### replace-sparc64-flags ####
41# Sets mcpu to v8 and uses the original value
42# as mtune if none specified.
43#
44#### filter-mfpmath <math types> ####
45# Remove specified math types from the fpmath specification
46# If the user has -mfpmath=sse,386, running `filter-mfpmath sse`
47# will leave the user with -mfpmath=386
48#
49#### append-ldflags ####
50# Add extra flags to your current LDFLAGS
51#
52#### etexec-flags ####
53# hooked function for hardened-gcc that appends
54# -yet_exec {C,CXX,LD}FLAGS when hardened-gcc is installed
55# and a package is filtering -fPIC,-fpic, -fPIE, -fpie
56#
57#### fstack-flags ####
58# hooked function for hardened-gcc that appends
59# -yno_propolice to {C,CXX,LD}FLAGS when hardened-gcc is installed
60# and a package is filtering -fstack-protector, -fstack-protector-all
61#
62
63# C[XX]FLAGS that we allow in strip-flags 29# {C,CXX,F,FC}FLAGS that we allow in strip-flags
30# Note: shell globs and character lists are allowed
64setup-allowed-flags() { 31setup-allowed-flags() {
65 export ALLOWED_FLAGS="-O -O1 -O2 -mcpu -march -mtune -fstack-protector -pipe -g" 32 if [[ -z ${ALLOWED_FLAGS} ]] ; then
66 case "${ARCH}" in 33 export ALLOWED_FLAGS="-pipe"
67 mips) ALLOWED_FLAGS="${ALLOWED_FLAGS} -mips1 -mips2 -mips3 -mips4 -mabi" ;; 34 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -O -O0 -O1 -O2 -mcpu -march -mtune"
68 amd64) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC" ;; 35 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fstack-protector -fstack-protector-all"
36 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fbounds-checking -fno-strict-overflow"
37 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-PIE -fno-pie -fno-unit-at-a-time"
38 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -g -g[0-9] -ggdb -ggdb[0-9] -gstabs -gstabs+"
39 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-ident"
69 alpha) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC" ;; 40 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -W* -w"
70 ia64) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC" ;; 41 fi
71 esac 42 # allow a bunch of flags that negate features / control ABI
43 ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-stack-protector -fno-stack-protector-all \
44 -fno-strict-aliasing -fno-bounds-checking -fstrict-overflow -fno-omit-frame-pointer"
45 ALLOWED_FLAGS="${ALLOWED_FLAGS} -mregparm -mno-app-regs -mapp-regs \
46 -mno-mmx -mno-sse -mno-sse2 -mno-sse3 -mno-3dnow \
47 -mips1 -mips2 -mips3 -mips4 -mips32 -mips64 -mips16 \
48 -msoft-float -mno-soft-float -mhard-float -mno-hard-float -mfpu \
49 -mieee -mieee-with-inexact -mschedule \
50 -mtls-direct-seg-refs -mno-tls-direct-seg-refs \
51 -mflat -mno-flat -mno-faster-structs -mfaster-structs \
52 -m32 -m64 -mabi -mlittle-endian -mbig-endian -EL -EB -fPIC \
53 -mlive-g0 -mcmodel -mstack-bias -mno-stack-bias \
54 -msecure-plt -m*-toc -D* -U*"
72 55
73 # C[XX]FLAGS that we are think is ok, but needs testing 56 # {C,CXX,F,FC}FLAGS that we are think is ok, but needs testing
74 # NOTE: currently -Os have issues with gcc3 and K6* arch's 57 # NOTE: currently -Os have issues with gcc3 and K6* arch's
75 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks -fprefetch-loop-arrays" 58 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks"
76 return 0 59 return 0
77} 60}
78 61
62# inverted filters for hardened compiler. This is trying to unpick
63# the hardened compiler defaults.
64_filter-hardened() {
65 local f
66 for f in "$@" ; do
67 case "${f}" in
68 # Ideally we should only concern ourselves with PIE flags,
69 # not -fPIC or -fpic, but too many places filter -fPIC without
70 # thinking about -fPIE.
71 -fPIC|-fpic|-fPIE|-fpie|-Wl,pie|-pie)
72 gcc-specs-pie || continue
73 is-flagq -nopie || append-flags -nopie;;
74 -fstack-protector)
75 gcc-specs-ssp || continue
76 is-flagq -fno-stack-protector || append-flags $(test-flags -fno-stack-protector);;
77 -fstack-protector-all)
78 gcc-specs-ssp-to-all || continue
79 is-flagq -fno-stack-protector-all || append-flags $(test-flags -fno-stack-protector-all);;
80 -fno-strict-overflow)
81 gcc-specs-nostrict || continue
82 is-flagq -fstrict-overflow || append-flags $(test-flags -fstrict-overflow);;
83 esac
84 done
85}
86
87# Remove occurrences of strings from variable given in $1
88# Strings removed are matched as globs, so for example
89# '-O*' would remove -O1, -O2 etc.
90_filter-var() {
91 local f x VAR VAL
92 declare -a new
93
94 VAR=$1
95 shift
96 eval VAL=\${${VAR}}
97 for f in ${VAL}; do
98 for x in "$@"; do
99 # Note this should work with globs like -O*
100 [[ ${f} == ${x} ]] && continue 2
101 done
102 eval new\[\${\#new\[@]}]=\${f}
103 done
104 eval export ${VAR}=\${new\[*]}
105}
106
107# @FUNCTION: filter-flags
108# @USAGE: <flags>
109# @DESCRIPTION:
110# Remove particular <flags> from {C,CPP,CXX,F,FC}FLAGS. Accepts shell globs.
79filter-flags() { 111filter-flags() {
80 for x in "$@" ; do 112 _filter-hardened "$@"
81 case "${x}" in 113 _filter-var CFLAGS "$@"
82 -fPIC|-fpic|-fPIE|-fpie|-pie) etexec-flags;; 114 _filter-var CPPFLAGS "$@"
83 -fstack-protector|-fstack-protector-all) fstack-flags;; 115 _filter-var CXXFLAGS "$@"
84 *) ;; 116 _filter-var FFLAGS "$@"
85 esac 117 _filter-var FCFLAGS "$@"
86 done
87
88 # we do this fancy spacing stuff so as to not filter
89 # out part of a flag ... we want flag atoms ! :D
90 CFLAGS=" ${CFLAGS} "
91 CXXFLAGS=" ${CXXFLAGS} "
92 for x in "$@" ; do
93 CFLAGS="${CFLAGS// ${x} / }"
94 CXXFLAGS="${CXXFLAGS// ${x} / }"
95 done
96 CFLAGS="${CFLAGS:1:${#CFLAGS}-2}"
97 CXXFLAGS="${CXXFLAGS:1:${#CXXFLAGS}-2}"
98 return 0 118 return 0
99} 119}
100 120
121# @FUNCTION: filter-lfs-flags
122# @DESCRIPTION:
123# Remove flags that enable Large File Support.
101filter-lfs-flags() { 124filter-lfs-flags() {
125 [[ -n $@ ]] && die "filter-lfs-flags takes no arguments"
102 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE 126 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
103} 127}
104 128
129# @FUNCTION: append-cppflags
130# @USAGE: <flags>
131# @DESCRIPTION:
132# Add extra <flags> to the current CPPFLAGS.
133append-cppflags() {
134 [[ -z $* ]] && return 0
135 export CPPFLAGS="${CPPFLAGS} $*"
136 return 0
137}
138
139# @FUNCTION: append-cflags
140# @USAGE: <flags>
141# @DESCRIPTION:
142# Add extra <flags> to the current CFLAGS.
143append-cppflags() {
144 [[ -z $* ]] && return 0
145 export CFLAGS="${CFLAGS} $*"
146 return 0
147}
148
149# @FUNCTION: append-cxxflags
150# @USAGE: <flags>
151# @DESCRIPTION:
152# Add extra <flags> to the current CXXFLAGS.
153append-cxxflags() {
154 [[ -z $* ]] && return 0
155 export CXXFLAGS="${CXXFLAGS} $*"
156 return 0
157}
158
159# @FUNCTION: append-fflags
160# @USAGE: <flags>
161# @DESCRIPTION:
162# Add extra <flags> to the current {F,FC}FLAGS.
163append-fflags() {
164 [[ -z $* ]] && return 0
165 export FFLAGS="${FFLAGS} $*"
166 export FCFLAGS="${FCFLAGS} $*"
167 return 0
168}
169
170# @FUNCTION: append-lfs-flags
171# @DESCRIPTION:
172# Add flags that enable Large File Support.
173append-lfs-flags() {
174 [[ -n $@ ]] && die "append-lfs-flags takes no arguments"
175 append-cppflags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
176}
177
178# @FUNCTION: append-flags
179# @USAGE: <flags>
180# @DESCRIPTION:
181# Add extra <flags> to your current {C,CXX,F,FC}FLAGS.
105append-flags() { 182append-flags() {
106 export CFLAGS="${CFLAGS} $@" 183 [[ -z $* ]] && return 0
107 export CXXFLAGS="${CXXFLAGS} $@" 184 append-cflags "$@"
108 [ "`is-flag -fno-stack-protector`" -o "`is-flag -fno-stack-protector-all`" ] && fstack-flags 185 append-cppflags "$@"
186 append-fflags "$@"
109 return 0 187 return 0
110} 188}
111 189
190# @FUNCTION: replace-flags
191# @USAGE: <old> <new>
192# @DESCRIPTION:
193# Replace the <old> flag with <new>. Accepts shell globs for <old>.
112replace-flags() { 194replace-flags() {
113 # we do this fancy spacing stuff so as to not filter 195 [[ $# != 2 ]] \
114 # out part of a flag ... we want flag atoms ! :D 196 && echo && eerror "Usage: replace-flags <old flag> <new flag>" \
115 CFLAGS=" ${CFLAGS} " 197 && die "replace-flags takes 2 arguments, not $#"
116 CXXFLAGS=" ${CXXFLAGS} "
117 CFLAGS="${CFLAGS// ${1} / ${2} }"
118 CXXFLAGS="${CXXFLAGS// ${1} / ${2} }"
119 CFLAGS="${CFLAGS:1:${#CFLAGS}-2}"
120 CXXFLAGS="${CXXFLAGS:1:${#CXXFLAGS}-2}"
121 return 0
122}
123 198
199 local f fset
200 declare -a new_CFLAGS new_CXXFLAGS new_FFLAGS new_FCFLAGS
201
202 for fset in CFLAGS CXXFLAGS FFLAGS FCFLAGS; do
203 # Looping over the flags instead of using a global
204 # substitution ensures that we're working with flag atoms.
205 # Otherwise globs like -O* have the potential to wipe out the
206 # list of flags.
207 for f in ${!fset}; do
208 # Note this should work with globs like -O*
209 [[ ${f} == ${1} ]] && f=${2}
210 eval new_${fset}\[\${\#new_${fset}\[@]}]=\${f}
211 done
212 eval export ${fset}=\${new_${fset}\[*]}
213 done
214
215 return 0
216}
217
218# @FUNCTION: replace-cpu-flags
219# @USAGE: <old> <new>
220# @DESCRIPTION:
221# Replace cpu flags (like -march/-mcpu/-mtune) that select the <old> cpu
222# with flags that select the <new> cpu. Accepts shell globs for <old>.
124replace-cpu-flags() { 223replace-cpu-flags() {
125 local newcpu="$1" ; shift 224 local newcpu="$#" ; newcpu="${!newcpu}"
126 local oldcpu="" 225 while [ $# -gt 1 ] ; do
127 for oldcpu in "$@" ; do 226 # quote to make sure that no globbing is done (particularly on
227 # ${oldcpu}) prior to calling replace-flags
128 replace-flags -march=${oldcpu} -march=${newcpu} 228 replace-flags "-march=${1}" "-march=${newcpu}"
129 replace-flags -mcpu=${oldcpu} -mcpu=${newcpu} 229 replace-flags "-mcpu=${1}" "-mcpu=${newcpu}"
130 replace-flags -mtune=${oldcpu} -mtune=${newcpu} 230 replace-flags "-mtune=${1}" "-mtune=${newcpu}"
231 shift
131 done 232 done
233 return 0
234}
235
236_is_flagq() {
237 local x
238 for x in ${!1} ; do
239 [[ ${x} == $2 ]] && return 0
240 done
132 return 0 241 return 1
133} 242}
134 243
244# @FUNCTION: is-flagq
245# @USAGE: <flag>
246# @DESCRIPTION:
247# Returns shell true if <flag> is in {C,CXX,F,FC}FLAGS, else returns shell false. Accepts shell globs.
248is-flagq() {
249 [[ -n $2 ]] && die "Usage: is-flag <flag>"
250 _is_flagq CFLAGS $1 || _is_flagq CXXFLAGS $1 || _is_flagq FFLAGS $1 || _is_flagq FCFLAGS $1
251}
252
253# @FUNCTION: is-flag
254# @USAGE: <flag>
255# @DESCRIPTION:
256# Echo's "true" if flag is set in {C,CXX,F,FC}FLAGS. Accepts shell globs.
135is-flag() { 257is-flag() {
136 for x in ${CFLAGS} ${CXXFLAGS} ; do 258 is-flagq "$@" && echo true
137 if [ "${x}" == "$1" ] ; then
138 echo true
139 return 0
140 fi
141 done
142 return 1
143} 259}
144 260
261# @FUNCTION: is-ldflagq
262# @USAGE: <flag>
263# @DESCRIPTION:
264# Returns shell true if <flag> is in LDFLAGS, else returns shell false. Accepts shell globs.
265is-ldflagq() {
266 [[ -n $2 ]] && die "Usage: is-ldflag <flag>"
267 _is_flagq LDFLAGS $1
268}
269
270# @FUNCTION: is-ldflag
271# @USAGE: <flag>
272# @DESCRIPTION:
273# Echo's "true" if flag is set in LDFLAGS. Accepts shell globs.
274is-ldflag() {
275 is-ldflagq "$@" && echo true
276}
277
278# @FUNCTION: filter-mfpmath
279# @USAGE: <math types>
280# @DESCRIPTION:
281# Remove specified math types from the fpmath flag. For example, if the user
282# has -mfpmath=sse,386, running `filter-mfpmath sse` will leave the user with
283# -mfpmath=386.
145filter-mfpmath() { 284filter-mfpmath() {
285 local orig_mfpmath new_math prune_math
286
146 # save the original -mfpmath flag 287 # save the original -mfpmath flag
147 local orig_mfpmath="`get-flag -mfpmath`" 288 orig_mfpmath=$(get-flag -mfpmath)
148 # get the value of the current -mfpmath flag 289 # get the value of the current -mfpmath flag
149 local new_math=" `get-flag mfpmath | tr , ' '` " 290 new_math=$(get-flag mfpmath)
291 new_math=" ${new_math//,/ } "
150 # figure out which math values are to be removed 292 # figure out which math values are to be removed
151 local prune_math="" 293 prune_math=""
152 for prune_math in "$@" ; do 294 for prune_math in "$@" ; do
153 new_math="${new_math/ ${prune_math} / }" 295 new_math=${new_math/ ${prune_math} / }
154 done 296 done
155 new_math="`echo ${new_math:1:${#new_math}-2} | tr ' ' ,`" 297 new_math=$(echo ${new_math})
298 new_math=${new_math// /,}
156 299
157 if [ -z "${new_math}" ] ; then 300 if [[ -z ${new_math} ]] ; then
158 # if we're removing all user specified math values are 301 # if we're removing all user specified math values are
159 # slated for removal, then we just filter the flag 302 # slated for removal, then we just filter the flag
160 filter-flags ${orig_mfpmath} 303 filter-flags ${orig_mfpmath}
161 else 304 else
162 # if we only want to filter some of the user specified 305 # if we only want to filter some of the user specified
164 replace-flags ${orig_mfpmath} -mfpmath=${new_math} 307 replace-flags ${orig_mfpmath} -mfpmath=${new_math}
165 fi 308 fi
166 return 0 309 return 0
167} 310}
168 311
312# @FUNCTION: strip-flags
313# @DESCRIPTION:
314# Strip C[XX]FLAGS of everything except known good/safe flags.
169strip-flags() { 315strip-flags() {
316 local x y flag NEW_CFLAGS NEW_CXXFLAGS NEW_FFLAGS NEW_FCFLAGS
317
170 setup-allowed-flags 318 setup-allowed-flags
171 319
172 local NEW_CFLAGS="" 320 local NEW_CFLAGS=""
173 local NEW_CXXFLAGS="" 321 local NEW_CXXFLAGS=""
322 local NEW_FFLAGS=""
323 local NEW_FCFLAGS=""
174 324
175 # Allow unstable C[XX]FLAGS if we are using unstable profile ... 325 # Allow unstable C[XX]FLAGS if we are using unstable profile ...
176 if [ `has ~${ARCH} ${ACCEPT_KEYWORDS}` ] ; then 326 if has ~$(tc-arch) ${ACCEPT_KEYWORDS} ; then
177 [ `use debug` ] && einfo "Enabling the use of some unstable flags"
178 ALLOWED_FLAGS="${ALLOWED_FLAGS} ${UNSTABLE_FLAGS}" 327 ALLOWED_FLAGS="${ALLOWED_FLAGS} ${UNSTABLE_FLAGS}"
179 fi 328 fi
180 329
181 set -f 330 set -f # disable pathname expansion
182 331
183 for x in ${CFLAGS} 332 for x in ${CFLAGS}; do
184 do
185 for y in ${ALLOWED_FLAGS} 333 for y in ${ALLOWED_FLAGS}; do
186 do
187 flag=${x%%=*} 334 flag=${x%%=*}
188 if [ "${flag%%${y}}" = "" ] 335 if [ "${flag%%${y}}" = "" ] ; then
189 then
190 NEW_CFLAGS="${NEW_CFLAGS} ${x}" 336 NEW_CFLAGS="${NEW_CFLAGS} ${x}"
191 break 337 break
192 fi 338 fi
193 done 339 done
194 done 340 done
195 341
196 for x in ${CXXFLAGS} 342 for x in ${CXXFLAGS}; do
197 do
198 for y in ${ALLOWED_FLAGS} 343 for y in ${ALLOWED_FLAGS}; do
199 do
200 flag=${x%%=*} 344 flag=${x%%=*}
201 if [ "${flag%%${y}}" = "" ] 345 if [ "${flag%%${y}}" = "" ] ; then
202 then
203 NEW_CXXFLAGS="${NEW_CXXFLAGS} ${x}" 346 NEW_CXXFLAGS="${NEW_CXXFLAGS} ${x}"
204 break 347 break
205 fi 348 fi
206 done 349 done
207 done 350 done
208 351
352 for x in ${FFLAGS}; do
353 for y in ${ALLOWED_FLAGS}; do
354 flag=${x%%=*}
355 if [ "${flag%%${y}}" = "" ] ; then
356 NEW_FFLAGS="${NEW_FFLAGS} ${x}"
357 break
358 fi
359 done
360 done
361
362 for x in ${FCFLAGS}; do
363 for y in ${ALLOWED_FLAGS}; do
364 flag=${x%%=*}
365 if [ "${flag%%${y}}" = "" ] ; then
366 NEW_FCFLAGS="${NEW_FCFLAGS} ${x}"
367 break
368 fi
369 done
370 done
371
209 # In case we filtered out all optimization flags fallback to -O2 372 # In case we filtered out all optimization flags fallback to -O2
210 if [ "${CFLAGS/-O}" != "${CFLAGS}" -a "${NEW_CFLAGS/-O}" = "${NEW_CFLAGS}" ]; then 373 if [ "${CFLAGS/-O}" != "${CFLAGS}" -a "${NEW_CFLAGS/-O}" = "${NEW_CFLAGS}" ]; then
211 NEW_CFLAGS="${NEW_CFLAGS} -O2" 374 NEW_CFLAGS="${NEW_CFLAGS} -O2"
212 fi 375 fi
213 if [ "${CXXFLAGS/-O}" != "${CXXFLAGS}" -a "${NEW_CXXFLAGS/-O}" = "${NEW_CXXFLAGS}" ]; then 376 if [ "${CXXFLAGS/-O}" != "${CXXFLAGS}" -a "${NEW_CXXFLAGS/-O}" = "${NEW_CXXFLAGS}" ]; then
214 NEW_CXXFLAGS="${NEW_CXXFLAGS} -O2" 377 NEW_CXXFLAGS="${NEW_CXXFLAGS} -O2"
215 fi 378 fi
379 if [ "${FFLAGS/-O}" != "${FFLAGS}" -a "${NEW_FFLAGS/-O}" = "${NEW_FFLAGS}" ]; then
380 NEW_FFLAGS="${NEW_FFLAGS} -O2"
381 fi
382 if [ "${FCFLAGS/-O}" != "${FCFLAGS}" -a "${NEW_FCFLAGS/-O}" = "${NEW_FCFLAGS}" ]; then
383 NEW_FCFLAGS="${NEW_FCFLAGS} -O2"
384 fi
216 385
217 set +f 386 set +f # re-enable pathname expansion
218
219 [ `use debug` ] \
220 && einfo "CFLAGS=\"${NEW_CFLAGS}\"" \
221 && einfo "CXXFLAGS=\"${NEW_CXXFLAGS}\""
222 387
223 export CFLAGS="${NEW_CFLAGS}" 388 export CFLAGS="${NEW_CFLAGS}"
224 export CXXFLAGS="${NEW_CXXFLAGS}" 389 export CXXFLAGS="${NEW_CXXFLAGS}"
390 export FFLAGS="${NEW_FFLAGS}"
391 export FCFLAGS="${NEW_FCFLAGS}"
392 return 0
393}
394
395test-flag-PROG() {
396 local comp=$1
397 local flags="$2"
398
399 [[ -z ${comp} || -z ${flags} ]] && \
225 return 0 400 return 1
226}
227 401
402 local PROG=$(tc-get${comp})
403 ${PROG} ${flags} -S -o /dev/null -xc /dev/null \
404 > /dev/null 2>&1
405}
406
407# @FUNCTION: test-flag-CC
408# @USAGE: <flag>
409# @DESCRIPTION:
410# Returns shell true if <flag> is supported by the C compiler, else returns shell false.
411test-flag-CC() { test-flag-PROG "CC" "$1"; }
412
413# @FUNCTION: test-flag-CXX
414# @USAGE: <flag>
415# @DESCRIPTION:
416# Returns shell true if <flag> is supported by the C++ compiler, else returns shell false.
417test-flag-CXX() { test-flag-PROG "CXX" "$1"; }
418
419# @FUNCTION: test-flag-F77
420# @USAGE: <flag>
421# @DESCRIPTION:
422# Returns shell true if <flag> is supported by the Fortran 77 compiler, else returns shell false.
423test-flag-F77() { test-flag-PROG "F77" "$1"; }
424
425# @FUNCTION: test-flag-FC
426# @USAGE: <flag>
427# @DESCRIPTION:
428# Returns shell true if <flag> is supported by the Fortran 90 compiler, else returns shell false.
429test-flag-FC() { test-flag-PROG "FC" "$1"; }
430
431test-flags-PROG() {
432 local comp=$1
433 local flags
434 local x
435
436 shift
437
438 [[ -z ${comp} ]] && return 1
439
440 x=""
441 for x in "$@" ; do
442 test-flag-${comp} "${x}" && flags="${flags}${flags:+ }${x}"
443 done
444
445 echo "${flags}"
446
447 # Just bail if we dont have any flags
448 [[ -n ${flags} ]]
449}
450
451# @FUNCTION: test-flags-CC
452# @USAGE: <flags>
453# @DESCRIPTION:
454# Returns shell true if <flags> are supported by the C compiler, else returns shell false.
455test-flags-CC() { test-flags-PROG "CC" "$@"; }
456
457# @FUNCTION: test-flags-CXX
458# @USAGE: <flags>
459# @DESCRIPTION:
460# Returns shell true if <flags> are supported by the C++ compiler, else returns shell false.
461test-flags-CXX() { test-flags-PROG "CXX" "$@"; }
462
463# @FUNCTION: test-flags-F77
464# @USAGE: <flags>
465# @DESCRIPTION:
466# Returns shell true if <flags> are supported by the Fortran 77 compiler, else returns shell false.
467test-flags-F77() { test-flags-PROG "F77" "$@"; }
468
469# @FUNCTION: test-flags-FC
470# @USAGE: <flags>
471# @DESCRIPTION:
472# Returns shell true if <flags> are supported by the Fortran 90 compiler, else returns shell false.
473test-flags-FC() { test-flags-PROG "FC" "$@"; }
474
475# @FUNCTION: test-flags
476# @USAGE: <flags>
477# @DESCRIPTION:
478# Short-hand that should hopefully work for both C and C++ compiler, but
479# its really only present due to the append-flags() abomination.
480test-flags() { test-flags-CC "$@"; }
481
482# @FUNCTION: test_flag
483# @DESCRIPTION:
484# DEPRICIATED, use test-flags()
228test_flag() { 485test_flag() {
229 if gcc -S -xc "$@" -o /dev/null /dev/null >/dev/null 2>&1; then 486 ewarn "test_flag: deprecated, please use test-flags()!" >&2
230 echo "$@" 487
488 test-flags-CC "$@"
489}
490
491# @FUNCTION: test_version_info
492# @USAGE: <version>
493# @DESCRIPTION:
494# Returns shell true if the current C compiler version matches <version>, else returns shell false.
495# Accepts shell globs.
496test_version_info() {
497 if [[ $($(tc-getCC) --version 2>&1) == *$1* ]]; then
231 return 0 498 return 0
232 fi 499 else
233 return 1 500 return 1
501 fi
234} 502}
235 503
504# @FUNCTION: strip-unsupported-flags
505# @DESCRIPTION:
506# Strip {C,CXX,F,FC}FLAGS of any flags not supported by the active toolchain.
236strip-unsupported-flags() { 507strip-unsupported-flags() {
237 for x in ${CFLAGS} ; do 508 export CFLAGS=$(test-flags-CC ${CFLAGS})
238 NEW_CFLAGS=${NEW_CFLAGS}" ""`test_flag ${x}`" 509 export CXXFLAGS=$(test-flags-CXX ${CXXFLAGS})
239 done 510 export FFLAGS=$(test-flags-F77 ${FFLAGS})
240 for x in ${CXXFLAGS} ; do 511 export FCFLAGS=$(test-flags-FC ${FCFLAGS})
241 NEW_CXXFLAGS=${NEW_CXXFLAGS}" ""`test_flag ${x}`"
242 done
243
244 export CFLAGS="${NEW_CFLAGS}"
245 export CXXFLAGS="${NEW_CXXFLAGS}"
246} 512}
247 513
514# @FUNCTION: get-flag
515# @USAGE: <flag>
516# @DESCRIPTION:
517# Find and echo the value for a particular flag. Accepts shell globs.
248get-flag() { 518get-flag() {
519 local f findflag="$1"
520
249 # this code looks a little flaky but seems to work for 521 # this code looks a little flaky but seems to work for
250 # everything we want ... 522 # everything we want ...
251 # for example, if CFLAGS="-march=i686": 523 # for example, if CFLAGS="-march=i686":
252 # `get-flags -march` == "-march=i686" 524 # `get-flag -march` == "-march=i686"
253 # `get-flags march` == "i686" 525 # `get-flag march` == "i686"
254 local findflag="$1"
255 for f in ${CFLAGS} ${CXXFLAGS} ; do 526 for f in ${CFLAGS} ${CXXFLAGS} ${FFLAGS} ${FCFLAGS} ; do
256 if [ "${f/${findflag}}" != "${f}" ] ; then 527 if [ "${f/${findflag}}" != "${f}" ] ; then
257 echo "${f/-${findflag}=}" 528 printf "%s\n" "${f/-${findflag}=}"
258 return 0 529 return 0
259 fi 530 fi
260 done 531 done
261 return 1 532 return 1
262} 533}
263 534
535# @FUNCTION: has_hardened
536# @DESCRIPTION:
537# DEPRECATED - use gcc-specs-relro or gcc-specs-now from toolchain-funcs
538has_hardened() {
539 ewarn "has_hardened: deprecated, please use gcc-specs-{relro,now}()!" >&2
540
541 test_version_info Hardened && return 0
542 # The specs file wont exist unless gcc has GCC_SPECS support
543 [[ -f ${GCC_SPECS} && ${GCC_SPECS} != ${GCC_SPECS/hardened/} ]]
544}
545
546# @FUNCTION: has_pic
547# @DESCRIPTION:
548# DEPRECATED - use gcc-specs-pie from toolchain-funcs
549# indicate whether PIC is set
550has_pic() {
551 ewarn "has_pic: deprecated, please use gcc-specs-pie()!" >&2
552
553 [[ ${CFLAGS/-fPIC} != ${CFLAGS} || \
554 ${CFLAGS/-fpic} != ${CFLAGS} ]] || \
555 gcc-specs-pie
556}
557
558# @FUNCTION: has_pie
559# @DESCRIPTION:
560# DEPRECATED - use gcc-specs-pie from toolchain-funcs
561# indicate whether PIE is set
562has_pie() {
563 ewarn "has_pie: deprecated, please use gcc-specs-pie()!" >&2
564
565 [[ ${CFLAGS/-fPIE} != ${CFLAGS} || \
566 ${CFLAGS/-fpie} != ${CFLAGS} ]] || \
567 gcc-specs-pie
568}
569
570# @FUNCTION: has_ssp_all
571# @DESCRIPTION:
572# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
573# indicate whether code for SSP is being generated for all functions
574has_ssp_all() {
575 ewarn "has_ssp_all: deprecated, please use gcc-specs-ssp()!" >&2
576
577 # note; this matches only -fstack-protector-all
578 [[ ${CFLAGS/-fstack-protector-all} != ${CFLAGS} || \
579 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP_ALL__) ]] || \
580 gcc-specs-ssp-to-all
581}
582
583# @FUNCTION: has_ssp
584# @DESCRIPTION:
585# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
586# indicate whether code for SSP is being generated
587has_ssp() {
588 ewarn "has_ssp: deprecated, please use gcc-specs-ssp()!" >&2
589
590 # note; this matches both -fstack-protector and -fstack-protector-all
591 [[ ${CFLAGS/-fstack-protector} != ${CFLAGS} || \
592 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP__) ]] || \
593 gcc-specs-ssp
594}
595
596# @FUNCTION: has_m64
597# @DESCRIPTION:
598# This doesn't test if the flag is accepted, it tests if the flag actually
599# WORKS. Non-multilib gcc will take both -m32 and -m64. If the flag works
600# return code is 0, else the return code is 1.
601has_m64() {
602 # this doesnt test if the flag is accepted, it tests if the flag
603 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
604 # please dont replace this function with test_flag in some future
605 # clean-up!
606
607 local temp="$(emktemp)"
608 echo "int main() { return(0); }" > "${temp}".c
609 MY_CC=$(tc-getCC)
610 ${MY_CC/ .*/} -m64 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
611 local ret=$?
612 rm -f "${temp}".c
613 [[ ${ret} != 1 ]] && return 0
614 return 1
615}
616
617# @FUNCTION: has_m32
618# @DESCRIPTION:
619# This doesn't test if the flag is accepted, it tests if the flag actually
620# WORKS. Non-mulilib gcc will take both -m32 and -64. If the flag works return
621# code is 0, else return code is 1.
622has_m32() {
623 # this doesnt test if the flag is accepted, it tests if the flag
624 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
625 # please dont replace this function with test_flag in some future
626 # clean-up!
627
628 [ "$(tc-arch)" = "amd64" ] && has_multilib_profile && return 0
629
630 local temp=$(emktemp)
631 echo "int main() { return(0); }" > "${temp}".c
632 MY_CC=$(tc-getCC)
633 ${MY_CC/ .*/} -m32 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
634 local ret=$?
635 rm -f "${temp}".c
636 [[ ${ret} != 1 ]] && return 0
637 return 1
638}
639
640# @FUNCTION: replace-sparc64-flags
641# @DESCRIPTION:
642# Sets mcpu to v8 and uses the original value as mtune if none specified.
264replace-sparc64-flags() { 643replace-sparc64-flags() {
265 local SPARC64_CPUS="ultrasparc v9" 644 local SPARC64_CPUS="ultrasparc3 ultrasparc v9"
266 645
267 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ] 646 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ]; then
268 then
269 for x in ${SPARC64_CPUS} 647 for x in ${SPARC64_CPUS}; do
270 do
271 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}" 648 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}"
272 done 649 done
273 else 650 else
274 for x in ${SPARC64_CPUS} 651 for x in ${SPARC64_CPUS}; do
275 do
276 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}" 652 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
277 done 653 done
278 fi 654 fi
279 655
280 if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ] 656 if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ]; then
281 then
282 for x in ${SPARC64_CPUS} 657 for x in ${SPARC64_CPUS}; do
283 do
284 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}" 658 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}"
285 done 659 done
286 else 660 else
287 for x in ${SPARC64_CPUS} 661 for x in ${SPARC64_CPUS}; do
288 do
289 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}" 662 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
290 done 663 done
291 fi 664 fi
292}
293 665
666 export CFLAGS CXXFLAGS
667}
668
669# @FUNCTION: append-ldflags
670# @USAGE: <flags>
671# @DESCRIPTION:
672# Add extra <flags> to the current LDFLAGS.
294append-ldflags() { 673append-ldflags() {
674 [[ -z $* ]] && return 0
675 local flag
676 for flag in "$@"; do
677 [[ ${flag} == -l* ]] && \
678 ewarn "Appending a library link instruction (${flag}); libraries to link to should not be passed through LDFLAGS"
679 done
680
295 LDFLAGS="${LDFLAGS} $@" 681 export LDFLAGS="${LDFLAGS} $*"
296 return 0 682 return 0
297} 683}
298 684
299etexec-flags() { 685# @FUNCTION: filter-ldflags
300 has_version sys-devel/hardened-gcc 686# @USAGE: <flags>
301 if [ $? == 0 ] ; then 687# @DESCRIPTION:
302 if [ "`is-flag -yet_exec`" != "true" ]; then 688# Remove particular <flags> from LDFLAGS. Accepts shell globs.
303 debug-print ">>> appending flags -yet_exec" 689filter-ldflags() {
304 append-flags -yet_exec 690 _filter-var LDFLAGS "$@"
305 append-ldflags -yet_exec 691 return 0
306 fi
307 fi
308} 692}
309 693
310fstack-flags() { 694# @FUNCTION: raw-ldflags
311 has_version sys-devel/hardened-gcc 695# @USAGE: <flags>
312 if [ $? == 0 ] ; then 696# @DESCRIPTION:
313 if [ "`is-flag -yno_propolice`" != "true" ]; then 697# Turn C style ldflags (-Wl,-foo) into straight ldflags - the results
314 debug-print ">>> appending flags -yno_propolice" 698# are suitable for passing directly to 'ld'; note LDFLAGS is usually passed
315 append-flags -yno_propolice 699# to gcc where it needs the '-Wl,'.
316 append-ldflags -yno_propolice 700raw-ldflags() {
317 fi 701 local x input="$@"
318 fi 702 [[ -z ${input} ]] && input=${LDFLAGS}
703 set --
704 for x in ${input} ; do
705 x=${x#-Wl,}
706 set -- "$@" ${x//,/ }
707 done
708 echo "$@"
319} 709}
710
711# @FUNCTION: bindnow-flags
712# @RETURN: Returns the flags to enable "now" binding in the current selected linker.
713# @DESCRIPTION:
714# DEPRECATED - Gets the flags needed for "NOW" binding
715bindnow-flags() {
716 ewarn "QA: stop using the bindnow-flags function ... simply drop it from your ebuild"
717}
718
719
720# Some tests for when we screw with things and want to make
721# sure we didn't break anything
722#TESTS() {
723# CFLAGS="-a -b -c=1"
724# CXXFLAGS="-x -y -z=2"
725# LDFLAGS="-l -m -n=3"
726#
727# die() { exit 1; }
728# (is-flag 1 2 3) && die
729# (is-ldflag 1 2 3) && die
730#
731# is-flagq -l && die
732# is-ldflagq -a && die
733# is-flagq -a || die
734# is-flagq -x || die
735# is-ldflagq -n=* || die
736# is-ldflagq -n && die
737#
738# strip-unsupported-flags
739# [[ ${CFLAGS} == "-c=1" ]] || die
740# [[ ${CXXFLAGS} == "-y -z=2" ]] || die
741#
742# echo "All tests pass"
743#}
744#TESTS

Legend:
Removed from v.1.40  
changed lines
  Added in v.1.136

  ViewVC Help
Powered by ViewVC 1.1.20